<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <ul class="nav nav-pills" id="pills-tab" role="tablist">
      <li v-for="tab1 in tabs" :key="tab1.id" class="nav-item" role="presentation">
        <button :class="['nav-link', { 'active': selectedTab === tab1.id }]" @click="selectTab(tab1.id)" :id="`pills-${tab1.value}-tab`" data-bs-toggle="pill" :data-bs-target="`#pills-${tab1.value}`" type="button" role="tab" :aria-controls="`pills-${tab1.value}`" aria-selected="true">{{ tab1.name }}</button>
      </li>
    </ul>
    <div class="tab-content" id="pills-tabContent">
      <template v-for="(tab, tabIndex) in tabs" :key="tab.id">
        <div :id="`pills-${tab.value}`" v-if="selectedTab === tab.id" role="tabpanel" :aria-labelledby="`pills-${tab.value}-tab`">
          <component :is="tab.component" :key="tabIndex" v-bind="tab.props || {}"></component>
        </div>
      </template>
    </div>
  </template>
  
<script setup lang="ts">
  import ArtifactsContent from '@/components/ArtifactsContent.vue';
  import DomainsContent from '@/components/DomainsContent.vue';
  import QualityContent from '@/components/QualityContent.vue';
  import GlossaryContent from '@/components/GlossaryContent.vue';
  import PermissionsContent from '@/components/PermissionsContent.vue';
  import SchemaContent from '@/components/SchemaContent.vue';
  // import MoreInfoContent from '@/components/MoreInfoContent.vue';

  const props = defineProps({
    data: {
      type: Object,
      required: true,
    },
  });


  /** DATASET - get related domains **/

  const domains = ref<any[]>([]);

  const fetchDomains = async () => {
    if (props.data && Array.isArray(props.data.domains)) {
      try {
        const domainNames = props.data.domains.map((domain: { name: string }) => domain.name);
        const fetchResults = await Promise.all(
          domainNames.map(async (domain: string) => {
            try {
              return await useFetchAuth(`/domains/${domain}`);
            } catch (error) {
              console.error('API Error:', error);
              return null;
            }
          })
        );
        domains.value = fetchResults.filter(result => result !== null);
      } catch (error) {
        console.error('Error in fetchDomains:', error);
      }
    } else {
      domains.value = []; // Clear domains if domainData is invalid
    }
  };

  watch(() => props?.data?.domains, (newDomains) => {
    if (Array.isArray(newDomains)) {
      fetchDomains();
    } else {
      domains.value = [];
    }
  }, { immediate: true });

  onMounted(() => {
    fetchDomains();
  }); 

  const tabs = computed(() => [
    {
      id: 1,
      name: 'Artifacts',
      value: 'artifacts',
      component: ArtifactsContent,
      props: { artifactsData: props?.data?.datasets || [] }
    },
    {
      id: 2,
      name: 'Domains',
      value: 'domains',
      component: DomainsContent,
      props: { domainData: domains}
    },
    {
      id: 3,  
      name: 'Quality',
      value: 'quality',
      component: QualityContent
    },
    {
      id: 4,
      name: 'Glossary',
      value: 'glossary',
      component: GlossaryContent,
      props: { glossaryData: props?.data?.terms }

    },
    {
      id: 5,
      name: 'Permissions',
      value: 'permissions',
      component: PermissionsContent
    },
    {
      id: 6,
      name: 'Schema',
      value: 'schema',
      component: SchemaContent
    }
    // {
    //   id: '6',
    //   name: 'More info',
    //   value: 'more',
    //   component: MoreInfoContent
    // }
  ]);

  const selectedTab = ref(tabs.value[0].id);
  const selectedComponent = computed(() => {
    const tab = tabs.value.find(tab => tab.id === selectedTab.value);
    return tab ? tab.component : null;
  });

  function selectTab(tabId: number) {
    selectedTab.value = tabId;
  }

  watch(() => props.data, async (newData) => {
    await nextTick();
  }, { immediate: true });
  </script>